/*
  Copyright 2018-2020, Barcelona Supercomputing Center (BSC), Spain
  Copyright 2015-2020, Johannes Gutenberg Universitaet Mainz, Germany

  This software was partially supported by the
  EC H2020 funded project NEXTGenIO (Project ID: 671951, www.nextgenio.eu).

  This software was partially supported by the
  ADA-FS project under the SPPEXA project funded by the DFG.

  SPDX-License-Identifier: MIT
*/

#ifndef GEKKOFS_CONFIG_MANAGER_HPP
#define GEKKOFS_CONFIG_MANAGER_HPP

#include <string>
#include <unordered_map>
#include <utility>
#include <vector>

using hostmap_t =
        std::unordered_map<uint64_t, std::pair<std::string, std::string>>;

namespace gkfs::relocation {

/**
 * @returns The hosts that need to be triggered for relocation.
 */
hostmap_t
calculate_random_slicing();

hostmap_t
read_hosts_file();

void
do_relocation(hostmap_t hosts);

} // namespace gkfs::relocation

#endif // GEKKOFS_CONFIG_MANAGER_HPP